import type { App } from "../App";
import type { AtomControl } from "../web/controls/AtomControl";
import type { AtomDisposableList } from "./AtomDisposableList";
import { AtomUri } from "./AtomUri";
import { displayRouteSymbol } from "./Command";
export declare class AtomLoader {
    static id: number;
    static load<T>(url: string | AtomUri | any, app: App): Promise<T>;
    static loadView<T extends {
        viewModel: any;
        element: any;
        dispose: () => any;
        disposables: AtomDisposableList;
    }>(url: AtomUri, app: App, hookCloseEvents: boolean, vmFactory?: () => any): Promise<{
        view: T;
        disposables?: AtomDisposableList;
        returnPromise?: Promise<any>;
        id?: string;
    }>;
    static loadClass<T extends AtomControl>(url: string | any, { title, [displayRouteSymbol]: route, ...parameters }: any, app: App): Promise<T>;
    static loadControl<T extends AtomControl>(url: AtomUri, app: App): Promise<T>;
}
//# sourceMappingURL=AtomLoader.d.ts.map