import { ColorItem } from "../core/Colors";
import WebImage from "../core/WebImage";
import { IStyleDeclaration } from "../web/styles/IStyleDeclaration";
export type StylePosition = "" | "default" | "initial" | "static" | "relative" | "absolute" | string;
export type TextAlignType = "" | "default" | "initial" | "left" | "right" | "center" | "justify";
export type FloatPosition = "" | "default" | "none" | "left" | "right" | "initial" | "inherit";
export type OverFlowType = "" | "default" | "visible" | "hidden" | "scroll" | "auto";
export type ItemAlignType = "" | "default" | "stretch" | "center" | "flex-start" | "flex-end" | "baseline" | "initial" | "inherit" | "start" | "end";
export type SelfAlignType = "" | "default" | "auto" | "stretch" | "center" | "flex-start" | "flex-end" | "baseline" | "initial" | "inherit";
export type ContentAlignType = "" | "default" | "stretch" | "center" | "flex-start" | "flex-end" | "space-between" | "space-around" | "initial" | "inherit";
export type JustifyType = "" | "default" | "auto" | "inter-word" | "inter-character" | "none" | "initial" | "inherit";
export type TextSize = "" | "default" | "medium" | "xx-small" | "x-small" | "small" | "large" | "x-large" | "xx-large" | "smaller" | "larger" | "initial" | "inherit";
export type AnimationType = "" | "animation-name" | "animation-duration" | "animation-timing-function" | "animation-delay" | "animation-iteration-count" | "animation-direction" | "animation-fill-mode" | "animation-play-state" | "initial" | "inherit";
export type AnimationNameType = "" | "keyframename" | "none" | "initial" | "inherit";
export type AnimationDirection = "" | "default" | "reverse" | "alternate" | "alternate-reverse" | "initial" | "inherit";
export type AnimationTimeType = "" | "initial" | "inherit";
export type AnimationModeType = "" | "default" | "none" | "forwards" | "backwards" | "both" | "initial" | "inherit";
export type IterationCount = "" | "default" | "infinite" | "initial" | "inherit";
export type PlayState = "" | "default" | "paused" | "running" | "initial" | "inherit";
export type TimingFunction = "" | "default" | "linear" | "ease" | "ease-in" | "ease-out" | "ease-in-out" | "step-start" | "step-end" | "steps()" | "cubic-bezier()" | "initial" | "inherit";
export type Visibility = "" | "default" | "visible" | "hidden" | "initial" | "inherit";
export type BackgroundType = "" | "background-color" | "background-image" | "background-position" | "background-size" | "background-repeat" | "background-origin" | "background-clip" | "background-attachment" | "initial" | "inherit";
export type BackgroundAttachmentType = "" | "default" | "scroll" | "fixed" | "local" | "initial" | "inherit" | string;
export type BackgroundBlendType = "" | "default" | "normal" | "multiply" | "screen" | "overlay" | "darken" | "lighten" | "color-dodge" | "saturation" | "color" | "luminosity" | "initial" | "inherit";
export type BackgroundClipType = "" | "default" | "border-box" | "padding-box" | "content-box" | "initial" | "inherit";
export type BackgroundImageType = "" | "default" | "url()" | "none" | "linear-gradient()" | "radial-gradient()" | "repeating-linear-gradient()" | "repeating-radial-gradient()" | "initial" | "inherit";
export type BackgroundOriginType = "" | "default" | "padding-box" | "border-box" | "content-box" | "initial" | "inherit";
export type BackgroundPositionType = "" | "default" | "left top" | "left center" | "left bottom" | "right top" | "right center" | "right bottom" | "center top" | "center center" | "center bottom" | "0% 0%" | "0px 0px" | "initial" | "inherit";
export type BackgroundRepeatType = "" | "default" | "repeat" | "repeat-x" | "repeat-y" | "no-repeat" | "space" | "round" | "initial" | "inherit";
export type BackgroundSizeType = "" | "default" | "auto" | "0px" | "0px 0px" | "0%" | "50% 50%" | "cover" | "contain" | "initial" | "inherit";
export type BorderStyleType = "" | "default" | "none" | "hidden" | "dotted" | "dashed" | "solid" | "double" | "groove" | "ridge" | "inset" | "outset" | "initial" | "inherit";
export type CommonWidthType = "" | "default" | "medium" | "thin" | "thick" | "initial" | "inherit";
export type BorderCollapseType = "" | "default" | "separate" | "collapse" | "initial" | "inherit";
export type BorderImageRepeatType = "" | "default" | "stretch" | "repeat" | "round" | "space" | "initial" | "inherit";
export type BorderSpacingType = "" | "default" | "0px" | "0px 0px" | "initial" | "inherit" | null | string;
export type BoxSizingType = "" | "default" | "border-box" | "content-box" | "initial" | "inherit";
export type CaptionSideType = "" | "default" | "top" | "bottom" | "initial" | "inherit";
export type ClearType = "" | "default" | "none" | "left" | "right" | "both" | "initial" | "inherit";
export type ColumnCountType = "" | "default" | "auto" | "initial" | "inherit" | number;
export type ColumnGapType = "" | "default" | "normal" | "initial" | "inherit";
export type ContentType = "" | "default" | "none" | "normal" | "counter" | "attr()" | "open-quote" | "close-quote" | "no-open-quote" | "no-close-quote" | "url()" | "initial" | "inherit";
export type CursorType = "" | "alias" | "all-scroll" | "auto" | "cell" | "context-menu" | "col-resize" | "copy" | "crosshair" | "default" | "e-resize" | "ew-resize" | "grab" | "grabbing" | "help" | "move" | "n-resize" | "ne-resize" | "nesw-resize" | "ns-resize" | "nw-resize" | "nwse-resize" | "no-drop" | "none" | "not-allowed" | "pointer" | "progress" | "row-resize" | "s-resize" | "se-resize" | "sw-resize" | "text" | "url()" | "vertical-text" | "w-resize" | "wait" | "zoom-in" | "zoom-out" | "initial" | "inherit";
export type DirectionType = "" | "default" | "ltr" | "rtl" | "initial" | "inherit";
export type DisplayType = "" | "default" | "inline" | "block" | "contents" | "flex" | "grid" | "inline-block" | "inline-flex" | "inline-grid" | "inline-table" | "list-item" | "run-in" | "table" | "table-caption" | "table-column-group" | "table-header-group" | "table-footer-group" | "table-row-group" | "table-cell" | "table-column" | "table-row" | "none" | "none" | "initial" | "inherit";
export type EmptyCellType = "" | "default" | "show" | "hide" | "initial" | "inherit";
export type FilterType = "" | "none" | "blur()" | "brightness()" | "contrast()" | "drop-shadow()" | "grayscale()" | "hue-rotate()" | "invert()" | "opacity()" | "saturate()" | "sepia()" | "url()" | "initial" | "inherit";
export type FlexDirectionType = "" | "default" | "row" | "row-reverse" | "column" | "column-reverse" | "initial" | "inherit";
export type FlexFlowDirectionType = "" | "default" | "column" | "column-reverse" | "nowrap" | "row" | "row-reverse" | "unset" | "wrap" | "wrap-reverse" | "initial" | "inherit";
export type FlexWrapType = "" | "default" | "nowrap" | "wrap" | "wrap-reverse" | "initial" | "inherit";
export type FloatType = "" | "default" | "none" | "left" | "right" | "initial" | "inherit";
export type FontStretchType = "" | "default" | "ultra-condensed" | "extra-condensed" | "condensed" | "semi-condensed" | "normal" | "semi-expanded" | "expanded" | "extra-expanded" | "ultra-expanded" | "initial" | "inherit";
export type FontStyleType = "" | "default" | "normal" | "italic" | "oblique" | "initial" | "inherit";
export type FontVariantType = "" | "default" | "normal" | "small-caps" | "initial" | "inherit";
export type FontWeightType = "" | "default" | "normal" | "bold" | "bolder" | "lighter" | "initial" | "inherit" | string;
export type GridAutoColumnsType = "" | "default" | "auto" | "max-content" | "min-content";
export type GridAutoFlowType = "" | "default" | "row" | "column" | "row dense" | "column dense";
export type GridAutoRowsType = "" | "default" | "auto" | "max-content" | "min-content";
export type JustifyContentType = "" | "default" | "flex-start" | "flex-end" | "center" | "space-between" | "space-around" | "initial" | "inherit";
export type ListStylePositionType = "" | "default" | "inside" | "max-content" | "outside" | "initial" | "inherit";
export type ListStyleType = "" | "default" | "disc" | "circle" | "none" | "square";
export type ObjectFitType = "" | "default" | "fill" | "contain" | "cover" | "none" | "scale-down" | "initial" | "inherit";
export type ObjectPositionType = "" | "default" | "fill" | "contain" | "cover" | "none" | "scale-down" | "initial" | "inherit";
export type PageBreakCommonType = "" | "default" | "auto" | "always" | "avoid" | "left" | "right" | "initial" | "inherit";
export type PageBreakInsideType = "" | "default" | "auto" | "avoid" | "initial" | "inherit";
export type ResizeType = "" | "default" | "none" | "both" | "horizontal" | "vertical" | "initial" | "inherit";
export type TableLayoutType = "" | "default" | "auto" | "fixed" | "initial" | "inherit";
export type TextAlignLastType = "" | "default" | "auto" | "left" | "right" | "center" | "justify" | "start" | "end" | "initial" | "inherit" | string;
export type TextDecorationType = "" | "none" | "underline" | "overline" | "line-through" | "initial" | "inherit";
export type TextTransformType = "" | "none" | "capitalize" | "uppercase" | "lowercase" | "initial" | "inherit";
export type TransformType = "" | "default" | "none" | "matrix()" | "matrix3d()" | "translate()" | "translate3d()" | "translateX()" | "translateY()" | "translateZ()" | "scale()" | "scale3d()" | "scaleX()" | "scaleY()" | "scaleZ()" | "rotate()" | "rotate3d()" | "rotateX()" | "rotateY()" | "rotateZ()" | "skew()" | "skewX()" | "skewY()" | "perspective()" | "initial" | "inherit";
export type TransformStyleType = "" | "default" | "flat" | "preserve-3d" | "initial" | "inherit";
export type VisibilityType = "" | "default" | "visible" | "hidden" | "collapse" | "initial" | "inherit";
export type WhiteSpaceType = "" | "default" | "normal" | "nowrap" | "pre" | "pre-line" | "pre-wrap" | "initial" | "inherit";
export type WordBreakType = "" | "default" | "normal" | "break-all" | "keep-all" | "break-word" | "initial" | "inherit";
export type WordSpacingType = "" | "default" | "normal" | "initial" | "inherit";
export type WordWrapType = "" | "default" | "normal" | "break-word" | "initial" | "inherit";
export type Units = "" | "px" | "pt" | "%" | "rem";
export interface IFlexAttributes {
    direction?: FlexDirectionType;
    alignItems?: ItemAlignType;
    justifyContent?: JustifyContentType;
    stretch?: boolean;
    inline?: boolean;
    /** Try to keep gap an even number as it hides borders of input/textarea for odd numbers */
    gap?: number;
}
export declare function toUnit(n: number | string, unit: string): string;
export interface IRect {
    top?: number | string;
    left?: number | string;
    right?: number | string;
    bottom?: number | string;
    width?: number | string;
    height?: number | string;
}
export declare class AtomStyleRules {
    style: IStyleDeclaration;
    name: string;
    constructor(name: string | object);
    alignContent(value: ContentAlignType): this;
    alignItems(value: ItemAlignType): this;
    alignSelf(value: SelfAlignType): this;
    alignmentBaseline(value: string): this;
    animation(value: AnimationType): this;
    animationDelay(value: AnimationTimeType): this;
    animationDirection(value: AnimationDirection): this;
    animationDuration(value: AnimationTimeType): this;
    animationFillMode(value: AnimationModeType): this;
    animationIterationCount(value: IterationCount): this;
    animationName(value: AnimationNameType): this;
    animationPlayState(value: PlayState): this;
    animationTimingFunction(value: TimingFunction): this;
    backfaceVisibility(value: Visibility): this;
    background(value: BackgroundType): this;
    backgroundAttachment(value: BackgroundAttachmentType): this;
    backgroundBlendMode(value: BackgroundBlendType): this;
    backgroundClip(value: BackgroundClipType): this;
    backgroundColor(value: string | ColorItem): this;
    backgroundImage(value: string | WebImage): this;
    backgroundOrigin(value: BackgroundOriginType): this;
    backgroundPosition(value: BackgroundPositionType): this;
    backgroundPositionX(value: number | string, unit?: Units): this;
    backgroundPositionY(value: number | string, unit?: Units): this;
    backgroundRepeat(value: BackgroundRepeatType): this;
    backgroundSize(value: BackgroundSizeType): this;
    baselineShift(value: string): this;
    border(value: string): this;
    borderBottom(value: string): this;
    borderBottomColor(value: string | ColorItem): this;
    borderBottomLeftRadius(value: number | string, unit?: Units): this;
    borderBottomRightRadius(value: number | string, unit?: Units): this;
    borderBottomStyle(value: BorderStyleType): this;
    borderBottomWidth(value: CommonWidthType): AtomStyleRules;
    borderBottomWidth(value: string): AtomStyleRules;
    borderBottomWidth(value: number, unit?: Units): AtomStyleRules;
    borderCollapse(value: BorderCollapseType): this;
    borderColor(value: string | ColorItem): this;
    borderImage(value: string): this;
    borderImageOutset(value: string): this;
    borderImageRepeat(value: BorderImageRepeatType): this;
    borderImageSlice(value: string): this;
    borderImageSource(value: string): this;
    borderImageWidth(value: string): this;
    borderLeft(value: string): this;
    borderLeftColor(value: string | ColorItem): this;
    borderLeftStyle(value: BorderStyleType): this;
    borderLeftWidth(value: CommonWidthType): AtomStyleRules;
    borderLeftWidth(value: string): AtomStyleRules;
    borderLeftWidth(value: number, unit?: Units): AtomStyleRules;
    borderRadius(value: string | number, unit?: Units): this;
    borderRight(value: string): this;
    borderRightColor(value: string | ColorItem): this;
    borderRightStyle(value: BorderStyleType): this;
    borderRightWidth(value: CommonWidthType): AtomStyleRules;
    borderRightWidth(value: string): AtomStyleRules;
    borderRightWidth(value: number, unit?: Units): AtomStyleRules;
    borderSpacing(value: BorderSpacingType): this;
    borderStyle(value: BorderStyleType): this;
    borderTop(value: string): this;
    borderTopColor(value: string | ColorItem): this;
    borderTopLeftRadius(value: number | string, unit?: Units): this;
    borderTopRightRadius(value: number | string, unit?: Units): this;
    borderTopStyle(value: BorderStyleType): this;
    borderTopWidth(value: CommonWidthType): AtomStyleRules;
    borderTopWidth(value: string): AtomStyleRules;
    borderTopWidth(value: number, unit?: Units): AtomStyleRules;
    borderWidth(value: CommonWidthType): AtomStyleRules;
    borderWidth(value: string): AtomStyleRules;
    borderWidth(value: number, unit?: Units): AtomStyleRules;
    bottom(value: number | string, unit?: Units): this;
    boxShadow(value: string): this;
    boxSizing(value: BoxSizingType): this;
    breakAfter(value: string): this;
    breakBefore(value: string): this;
    breakInside(value: string): this;
    captionSide(value: CaptionSideType): this;
    caretColor(value: ColorItem | string): this;
    clear(value: ClearType): this;
    clip(value: string): this;
    clipPath(value: string): this;
    clipRule(value: string): this;
    color(value: string | ColorItem): this;
    colorInterpolationFilters(value: string): this;
    columnCount(value: any): this;
    columnFill(value: string): this;
    columnGap(value: ColumnGapType): any;
    columnGap(value: string): AtomStyleRules;
    columnRule(value: string): this;
    columnRuleColor(value: any | ColorItem): this;
    columnRuleStyle(value: BorderStyleType): this;
    columnRuleWidth(value: CommonWidthType): this;
    columnSpan(value: string): this;
    columnWidth(value: any): this;
    columns(value: string): this;
    content(value: ContentType): this;
    counterIncrement(value: string): this;
    counterReset(value: string): this;
    cssFloat(value: FloatPosition): this;
    cssText(value: string): this;
    cursor(value: CursorType): this;
    direction(value: DirectionType): this;
    display(value: DisplayType): this;
    dominantBaseline(value: string): this;
    emptyCells(value: EmptyCellType): this;
    enableBackground(value: string): this;
    fill(value: string): this;
    fillOpacity(value: string): this;
    fillRule(value: string): this;
    filter(value: FilterType): this;
    flex(value: string): this;
    flexBasis(value: string): this;
    flexDirection(value: FlexDirectionType): this;
    flexFlow(value: FlexFlowDirectionType): this;
    flexGrow(value: string): this;
    flexShrink(value: string): this;
    flexWrap(value: FlexWrapType): this;
    float(value: FloatType): this;
    floodColor(value: string | ColorItem): this;
    floodOpacity(value: string): this;
    font(value: string): this;
    fontFamily(value: string): this;
    fontFeatureSettings(value: string): this;
    fontSize(value: number): AtomStyleRules;
    fontSize(value: TextSize): AtomStyleRules;
    fontSize(value: string): AtomStyleRules;
    fontSizeAdjust(value: string): this;
    fontStretch(value: FontStretchType): this;
    fontStyle(value: FontStyleType): this;
    fontVariant(value: FontVariantType): this;
    fontWeight(value: FontWeightType): this;
    gap(value: number | string, unit?: Units): this;
    glyphOrientationHorizontal(value: string): this;
    glyphOrientationVertical(value: string): this;
    grid(value: string): this;
    gridArea(value: string): this;
    gridAutoColumns(value: GridAutoColumnsType): this;
    gridAutoFlow(value: GridAutoFlowType): this;
    gridAutoRows(value: GridAutoRowsType): this;
    gridColumn(value: string): this;
    gridColumnEnd(value: string): this;
    gridColumnGap(value: string): this;
    gridColumnStart(value: string): this;
    gridGap(value: string): this;
    gridRow(value: string): this;
    gridRowEnd(value: string): this;
    gridRowGap(value: string): this;
    gridRowStart(value: string): this;
    gridTemplate(value: string): this;
    gridTemplateAreas(value: string): this;
    gridTemplateColumns(value: string): this;
    gridTemplateRows(value: string): this;
    height(value: number | string, unit?: Units): this;
    imeMode(value: string): this;
    justifyContent(value: JustifyContentType): this;
    justifyItems(value: string): this;
    justifySelf(value: string): this;
    kerning(value: string): this;
    layoutGrid(value: string): this;
    layoutGridChar(value: string): this;
    layoutGridLine(value: string): this;
    layoutGridMode(value: string): this;
    layoutGridType(value: string): this;
    left(value: number | string, unit?: Units): this;
    letterSpacing(value: string): this;
    lightingColor(value: string | ColorItem): this;
    lineBreak(value: string): this;
    lineHeight(value: string): this;
    listStyle(value: string): this;
    listStyleImage(value: string): this;
    listStylePosition(value: ListStylePositionType): this;
    listStyleType(value: ListStyleType): this;
    margin(value: number | string, unit?: Units): this;
    marginBottom(value: number | string, unit?: Units): this;
    marginLeft(value: number | string, unit?: Units): this;
    marginRight(value: number | string, unit?: Units): this;
    marginTop(value: number | string, unit?: Units): this;
    marginInlineStart(value: number | string, unit?: Units): this;
    marginInlineEnd(value: number | string, unit?: Units): this;
    marginBlockStart(value: number | string, unit?: Units): this;
    marginBlockEnd(value: number | string, unit?: Units): this;
    marker(value: string): this;
    markerEnd(value: string): this;
    markerMid(value: string): this;
    markerStart(value: string): this;
    mask(value: string): this;
    maskImage(value: string): this;
    maxHeight(value: number | string, unit?: Units): this;
    maxWidth(value: number | string, unit?: Units): this;
    minHeight(value: number | string, unit?: Units): this;
    minWidth(value: number | string, unit?: Units): this;
    msContentZoomChaining(value: string): this;
    msContentZoomLimit(value: string): this;
    msContentZoomLimitMax(value: any): this;
    msContentZoomLimitMin(value: any): this;
    msContentZoomSnap(value: string): this;
    msContentZoomSnapPoints(value: string): this;
    msContentZoomSnapType(value: string): this;
    msContentZooming(value: string): this;
    msFlowFrom(value: string): this;
    msFlowInto(value: string): this;
    msFontFeatureSettings(value: string): this;
    msGridColumn(value: any): this;
    msGridColumnAlign(value: string): this;
    msGridColumnSpan(value: any): this;
    msGridColumns(value: string): this;
    msGridRow(value: any): this;
    msGridRowAlign(value: string): this;
    msGridRowSpan(value: any): this;
    msGridRows(value: string): this;
    msHighContrastAdjust(value: string): this;
    msHyphenateLimitChars(value: string): this;
    msHyphenateLimitLines(value: any): this;
    msHyphenateLimitZone(value: any): this;
    msHyphens(value: string): this;
    msImeAlign(value: string): this;
    msOverflowStyle(value: string): this;
    msScrollChaining(value: string): this;
    msScrollLimit(value: string): this;
    msScrollLimitXMax(value: any): this;
    msScrollLimitXMin(value: any): this;
    msScrollLimitYMax(value: any): this;
    msScrollLimitYMin(value: any): this;
    msScrollRails(value: string): this;
    msScrollSnapPointsX(value: string): this;
    msScrollSnapPointsY(value: string): this;
    msScrollSnapType(value: string): this;
    msScrollSnapX(value: string): this;
    msScrollSnapY(value: string): this;
    msScrollTranslation(value: string): this;
    msTextCombineHorizontal(value: string): this;
    msTextSizeAdjust(value: any): this;
    msTouchAction(value: string): this;
    msTouchSelect(value: string): this;
    msUserSelect(value: string): this;
    msWrapFlow(value: string): this;
    msWrapMargin(value: any): this;
    msWrapThrough(value: string): this;
    objectFit(value: ObjectFitType): this;
    objectPosition(value: ObjectPositionType): this;
    opacity(value: string): this;
    order(value: string): this;
    orphans(value: string): this;
    outline(value: string): this;
    outlineColor(value: string | ColorItem): this;
    outlineOffset(value: string): this;
    outlineStyle(value: BorderStyleType): this;
    outlineWidth(value: CommonWidthType): this;
    overflow(value: OverFlowType): this;
    overflowX(value: OverFlowType): this;
    overflowY(value: OverFlowType): this;
    padding(value: number | string, unit?: Units): this;
    paddingBottom(value: number | string, unit?: Units): this;
    paddingLeft(value: number | string, unit?: Units): this;
    paddingRight(value: number | string, unit?: Units): this;
    paddingTop(value: number | string, unit?: Units): this;
    paddingInlineStart(value: number | string, unit?: Units): this;
    paddingInlineEnd(value: number | string, unit?: Units): this;
    pageBreakAfter(value: PageBreakCommonType): this;
    pageBreakBefore(value: PageBreakCommonType): this;
    pageBreakInside(value: PageBreakInsideType): this;
    penAction(value: string): this;
    perspective(value: string): this;
    perspectiveOrigin(value: string): this;
    pointerEvents(value: string): this;
    position(value: StylePosition): this;
    quotes(value: string): this;
    resize(value: ResizeType): this;
    right(value: number | string, unit?: Units): this;
    rotate(value: string): this;
    rowGap(value: string): this;
    rubyAlign(value: string): this;
    rubyOverhang(value: string): this;
    rubyPosition(value: string): this;
    scale(value: string): this;
    custom(name: string, value: string): this;
    scrollBarWidth(value: string): AtomStyleRules;
    scrollBarWidth(value: number, unit?: Units): AtomStyleRules;
    scrollBarColor(thumb: ColorItem | string, bg: ColorItem | string): this;
    stopColor(value: string | ColorItem): this;
    stopOpacity(value: string): this;
    stroke(value: string): this;
    strokeDasharray(value: string): this;
    strokeDashoffset(value: string): this;
    strokeLinecap(value: string): this;
    strokeLinejoin(value: string): this;
    strokeMiterlimit(value: string): this;
    strokeOpacity(value: string): this;
    strokeWidth(value: string): this;
    tableLayout(value: TableLayoutType): this;
    textAlign(value: TextAlignType): this;
    textAlignLast(value: TextAlignLastType): this;
    textAnchor(value: string): this;
    textCombineUpright(value: string): this;
    textDecoration(value: TextDecorationType): this;
    textIndent(value: string): this;
    textJustify(value: JustifyType): this;
    textKashida(value: string): this;
    textKashidaSpace(value: string): this;
    textOverflow(value: string): this;
    textShadow(value: string): this;
    textTransform(value: TextTransformType): this;
    textUnderlinePosition(value: string): this;
    top(value: number | string, unit?: Units): this;
    touchAction(value: string): this;
    transform(value: TransformType): this;
    transformOrigin(value: string): this;
    transformStyle(value: TransformStyleType): this;
    transition(value: string): this;
    transitionDelay(value: string): this;
    transitionDuration(value: string): this;
    transitionProperty(value: string): this;
    transitionTimingFunction(value: string): this;
    translate(value: string): this;
    unicodeBidi(value: string): this;
    userSelect(value: string): this;
    userDrag(value: string): this;
    verticalAlign(value: string): this;
    visibility(value: VisibilityType): this;
    webkitAlignContent(value: string): this;
    webkitAlignItems(value: string): this;
    webkitAlignSelf(value: string): this;
    webkitAnimation(value: string): this;
    webkitAnimationDelay(value: string): this;
    webkitAnimationDirection(value: string): this;
    webkitAnimationDuration(value: string): this;
    webkitAnimationFillMode(value: string): this;
    webkitAnimationIterationCount(value: string): this;
    webkitAnimationName(value: string): this;
    webkitAnimationPlayState(value: string): this;
    webkitAnimationTimingFunction(value: string): this;
    webkitAppearance(value: string): this;
    webkitBackfaceVisibility(value: string): this;
    webkitBackgroundClip(value: string): this;
    webkitBackgroundOrigin(value: string): this;
    webkitBackgroundSize(value: string): this;
    webkitBorderBottomLeftRadius(value: string): this;
    webkitBorderBottomRightRadius(value: string): this;
    webkitBorderImage(value: string): this;
    webkitBorderRadius(value: string): this;
    webkitBorderTopLeftRadius(value: string): this;
    webkitBorderTopRightRadius(value: string): this;
    webkitBoxAlign(value: string): this;
    webkitBoxDirection(value: string): this;
    webkitBoxFlex(value: string): this;
    webkitBoxOrdinalGroup(value: string): this;
    webkitBoxOrient(value: string): this;
    webkitBoxPack(value: string): this;
    webkitBoxSizing(value: string): this;
    webkitColumnBreakAfter(value: string): this;
    webkitColumnBreakBefore(value: string): this;
    webkitColumnBreakInside(value: string): this;
    webkitColumnCount(value: any): this;
    webkitColumnGap(value: any): this;
    webkitColumnRule(value: string): this;
    webkitColumnRuleColor(value: any | ColorItem): this;
    webkitColumnRuleStyle(value: string): this;
    webkitColumnRuleWidth(value: any): this;
    webkitColumnSpan(value: string): this;
    webkitColumnWidth(value: any): this;
    webkitColumns(value: string): this;
    webkitFilter(value: string): this;
    webkitFlex(value: string): this;
    webkitFlexBasis(value: string): this;
    webkitFlexDirection(value: string): this;
    webkitFlexFlow(value: string): this;
    webkitFlexGrow(value: string): this;
    webkitFlexShrink(value: string): this;
    webkitFlexWrap(value: string): this;
    webkitJustifyContent(value: string): this;
    webkitOrder(value: string): this;
    webkitPerspective(value: string): this;
    webkitPerspectiveOrigin(value: string): this;
    webkitTapHighlightColor(value: string | ColorItem): this;
    webkitTextFillColor(value: string | ColorItem): this;
    webkitTextSizeAdjust(value: any): this;
    webkitTextStroke(value: string): this;
    webkitTextStrokeColor(value: string | ColorItem): this;
    webkitTextStrokeWidth(value: string): this;
    webkitTransform(value: string): this;
    webkitTransformOrigin(value: string): this;
    webkitTransformStyle(value: string): this;
    webkitTransition(value: string): this;
    webkitTransitionDelay(value: string): this;
    webkitTransitionDuration(value: string): this;
    webkitTransitionProperty(value: string): this;
    webkitTransitionTimingFunction(value: string): this;
    webkitUserModify(value: string): this;
    webkitUserSelect(value: string): this;
    webkitUserDrag(value: string): this;
    webkitWritingMode(value: string): this;
    whiteSpace(value: WhiteSpaceType): this;
    widows(value: string): this;
    width(value: string | number, unit?: Units): this;
    wordBreak(value: WordBreakType): this;
    wordSpacing(value: WordSpacingType): this;
    wordWrap(value: WordWrapType): this;
    writingMode(value: string): this;
    zIndex(value: string | number): this;
    zoom(value: string): this;
    displayFlex(): this;
    flexStretch(): this;
    roundBorderFull(): this;
    subclass(name: string, style: IStyleDeclaration | AtomStyleRules): this;
    childSubclass(name: string, style: IStyleDeclaration | AtomStyleRules): this;
    subclasses(...styles: AtomStyleRules[]): this;
    /**
     * Creates rule for immediate child like `this > child`
     * @param styles children
     * @returns this
     */
    childSubclasses(...styles: AtomStyleRules[]): this;
    roundBox(bgColor: string | ColorItem, padding?: number, radius?: number, unit?: Units): this;
    maximizeAbsolute(): this;
    setRect(position: string, { top, left, right, bottom, width, height }?: IRect, unit?: Units): this;
    absolutePosition(rect?: IRect, unit?: Units): this;
    relativePosition(rect?: IRect, unit?: Units): this;
    absoluteDockTop(height: number | string, unit?: Units): this;
    absoluteDockBottom(top: number | string, unit?: Units): this;
    defaultBoxShadow(): this;
    textEllipsis(): this;
    hover(style: AtomStyleRules): this;
    focus(style: AtomStyleRules): this;
    hoverBackgroundColor(color: ColorItem | string): this;
    hoverColor(color: ColorItem | string): this;
    and(...styles: AtomStyleRules[]): this;
    nested(...styles: AtomStyleRules[]): this;
    child(...styles: AtomStyleRules[]): this;
    merge(...styles: AtomStyleRules[]): this;
    toStyleSheet(): string;
    /**
     * @deprecated Please use `displayNone(":not(XX) > A.XX")` format
     * @param showSelector showSelector
     * @param hideSelector hideSelector
     * @returns AtomStyleRule
     */
    toggle(showSelector: string, hideSelector: string): this;
    displayNone(...selectors: string[]): this;
    /**
     * Creates vertical flex layout with 5px gap
     * @param p defaults { direction: "column", alignItems: "center", justifyContent: "space-around" }
     * @param units px
     */
    verticalFlexLayout(a?: IFlexAttributes, units?: Units): this;
    /**
     * Creates flex layout with 5px gap
     * @param p defaults { direction: "row", alignItems: "center", justifyContent: "space-around" }
     * @param units px
     */
    flexLayout({ direction, alignItems, justifyContent, stretch, inline, gap }?: IFlexAttributes, units?: Units): this;
    toString(): string;
}
/**
 * Creates new style rule
 * @param selector [optional] name of child subclass
 * @returns StyleRuleClass
 */
declare function StyleRule(selector?: string): AtomStyleRules;
export default StyleRule;
//# sourceMappingURL=StyleRule.d.ts.map