System.register(["../core/AtomDisposableList", "../core/AtomOnce", "../core/AtomUri"], function (_export, _context) {
  "use strict";

  var AtomDisposableList, AtomOnce, AtomUri;
  function bindUrlParameter(vm, name, urlParameter) {
    if (!name) {
      return;
    }
    if (!urlParameter) {
      return;
    }
    const a = vm;
    const paramDisposables = a.mUrlParameters || (a.mUrlParameters = {});
    const old = paramDisposables[name];
    if (old) {
      old.dispose();
      paramDisposables[name] = null;
    }
    const disposables = new AtomDisposableList();
    const updater = new AtomOnce();
    disposables.add(a.setupWatch([["app", "url", "hash", urlParameter], ["app", "url", "query", urlParameter]], (hash, query) => {
      updater.run(() => {
        const value = hash || query;
        if (value) {
          if (value != vm[name]) {
            vm[name] = value;
          }
        }
      });
    }));
    disposables.add(a.setupWatch([[name]], value => {
      updater.run(() => {
        const url = vm.app.url || (vm.app.url = new AtomUri(""));
        url.hash[urlParameter] = value;
        vm.app.syncUrl();
      });
    }));
    paramDisposables[name] = disposables;
    if (vm.app.url) {
      const v = vm.app.url.hash[urlParameter] || vm.app.url.query[urlParameter];
      if (v) {
        vm[name] = v;
      }
    }
    return vm.registerDisposable(disposables);
  }
  _export("default", bindUrlParameter);
  return {
    setters: [function (_coreAtomDisposableList) {
      AtomDisposableList = _coreAtomDisposableList.AtomDisposableList;
    }, function (_coreAtomOnce) {
      AtomOnce = _coreAtomOnce.AtomOnce;
    }, function (_coreAtomUri) {
      AtomUri = _coreAtomUri.AtomUri;
    }],
    execute: function () {}
  };
});
//# sourceMappingURL=bindUrlParameter.js.map