System.register(["../styles/AtomListBoxStyle", "./AtomItemsControl"], function (_export, _context) {
  "use strict";

  var AtomListBoxStyle, AtomItemsControl, AtomListBox;
  _export("AtomListBox", void 0);
  return {
    setters: [function (_stylesAtomListBoxStyle) {
      AtomListBoxStyle = _stylesAtomListBoxStyle.AtomListBoxStyle;
    }, function (_AtomItemsControl) {
      AtomItemsControl = _AtomItemsControl.AtomItemsControl;
    }],
    execute: function () {
      _export("AtomListBox", AtomListBox = class AtomListBox extends AtomItemsControl {
        preCreate() {
          this.selectItemOnClick = true;
          super.preCreate();
          this.defaultControlStyle = AtomListBoxStyle;
          this.registerItemClick();
          this.runAfterInit(() => this.setElementClass(this.element, {
            [this.controlStyle.name]: 1,
            "atom-list-box": 1
          }));
        }
        registerItemClick() {
          this.bindEvent(this.element, "click", e => {
            const p = this.atomParent(e.target);
            if (p === this) {
              return;
            }
            if (p.element._logicalParent === this.element) {
              const data = p.data;
              if (!data) {
                return;
              }
              if (this.selectItemOnClick) {
                this.toggleSelection(data);
                const ce = new CustomEvent("selectionChanged", {
                  bubbles: false,
                  cancelable: false,
                  detail: data
                });
                this.element.dispatchEvent(ce);
              }
            }
          });
        }
        createChild(df, data) {
          const child = super.createChild(df, data);
          child.bind(child.element, "styleClass", [["this", "version"], ["data"], ["this", "selectedItems"]], false, (version, itemData, selectedItems) => {
            return {
              "list-item": true,
              "item": true,
              "selected-item": selectedItems && selectedItems.find(x => x === itemData),
              "selected-list-item": selectedItems && selectedItems.find(x => x === itemData)
            };
          }, this);
          return child;
        }
      });
    }
  };
});
//# sourceMappingURL=AtomListBox.js.map