System.register(["../../core/XNode", "./PopupService", "./NotifcationPopup.global.css"], function (_export, _context) {
  "use strict";

  var XNode, PopupWindow, css;
  function NotificationPopup({
    message,
    type
  }) {
    return class Notification extends PopupWindow {
      create() {
        if (message instanceof XNode) {
          this.render(XNode.create("div", {
            styleClass: {
              [css]: 1,
              error: /error/i.test(type),
              warning: /warn/i.test(type)
            }
          }, message));
          return;
        }
        this.render(XNode.create("div", {
          styleClass: {
            [css]: 1,
            error: /error/i.test(type),
            warning: /warn/i.test(type)
          },
          formattedText: message
        }));
      }
    };
  }
  _export("default", NotificationPopup);
  return {
    setters: [function (_coreXNode) {
      XNode = _coreXNode.default;
    }, function (_PopupService) {
      PopupWindow = _PopupService.PopupWindow;
    }, function (_NotifcationPopupGlobalCss) {}],
    execute: function () {
      css = "web-atoms-notification-popup";
    }
  };
});
//# sourceMappingURL=NotificationPopup.js.map